module Core.Handlers where

import qualified Core.Configuration     as Conf
import           Core.Rendering 
import           Fragments.Base
import           Fragments.NotFound

import           Control.Monad.IO.Class (liftIO)
import           Lucid                  (Html)
import           Web.Twain

index :: ResponderM a
index = do 
  -- Probably going to want to add ReaderT to the stack for this instead
  title  <- liftIO Conf.appTitle
  -- Probably going to want to do this file reading and processing at app init
  homeMd <- liftIO $ mdFileToLucid "./data/base/home.md"
  sendLucidFragment 
    $ baseDoc title 
    $ baseNav 
   <> baseHome homeMd

posts :: FilePath -> ResponderM a 
posts fp = do
  title <- liftIO Conf.appTitle
  postMd <- liftIO $ mdFileToLucid 
                   $ "./data/posts/" ++ fp ++ ".md"
  sendLucidFragment
    $ baseDoc title
    $ baseNav
    <> postMd
  
missing :: ResponderM a
missing = sendLucidFragment pageNotFound

sendLucidFragment :: Html () -> ResponderM a
sendLucidFragment x = send $ html $ lucidToTwain x
