module Fragments.Base where

import Core.Rendering 

import Data.Text
import Data.String    (fromString)
import Lucid

baseDoc :: String -> Html () -> Html ()
baseDoc title bodyContent = doctypehtml_ $ do
  head_ $ do
    title_ $ fromString title
    link_ [rel_ "stylesheet", type_ "text/css", href_ "/style.css"]
    script_ [src_ "/htmx.min.js"] none
  body_ bodyContent

baseNav :: Html ()
baseNav = div_ [class_ "navContainer"] $ do
  ul_ [class_ "mainNav"] $ do
    li_ $ a_ [href_ "/"]        "Home"
    li_ $ a_ [href_ "/posts"]   "Posts"
    li_ $ a_ [href_ "/contact"] "Contact"
    li_ $ a_ [href_ "/feed"]    "Feed"

baseHome :: Html () -> Html ()
baseHome content = div_ [class_ "main"] content
  
none :: Text
none = mempty
